<template>
  <layout-auth>
    <div class="row">
      <div class="col-xs-12 col-sm-4 col-md-4 mx-auto">
        <e-panel title="Login Admin" style="margin-top: 100px">
          <b-alert variant="danger" :show="form.errors.any()" dismissible>Login failed.</b-alert>

          <form>
            <div class="form-group row">
              <label class="col-md-3 col-form-label">Username</label>
              <div class="col-md-9">
                <b-input type="text" :state="form.getInputState('username')" v-model="form.username" placeholder="Username" />
                <b-form-invalid-feedback :state="form.getInputState('username')">
                  {{ form.errors.get('username') }}
                </b-form-invalid-feedback>
              </div>
            </div>
            <div class="form-group row">
              <label class="col-md-3 col-form-label">Password</label>
              <div class="col-md-9">
                <b-input type="password" :state="form.getInputState('password')" v-model="form.password" placeholder="Password" />
                <b-form-invalid-feedback :state="form.getInputState('password')">
                  {{ form.errors.get('password') }}
                </b-form-invalid-feedback>
              </div>
            </div>
            <hr class="mb-3">
            <div class="form-group row mb-0">
              <div class="col-md-10">
                <button type="button" class="btn btn-primary" v-promise-btn @click="makeLogin">Login</button>
                <button type="button" class="btn btn-light" v-promise-btn @click="form.reset()">Reset</button>
              </div>
            </div>
          </form>
        </e-panel>
      </div>
    </div>
  </layout-auth>
</template>

<script>
import Form from '@/lib/Form'

import authService from '@/services/auth.service'

import LayoutAuth from '@/pages/layouts/Auth'
import EPanel from '@/lib/components/panel'

export default {
  components: {
    LayoutAuth,
    EPanel
  },

  data () {
    return {
      form: new Form({
        username: null,
        password: null
      })
    }
  },

  methods: {
    makeLogin () {
      return this.form.callService(authService.makeLogin(this.form.data()))
        .then(() => this.$router.push('/'))
        .catch(error => {
          if (error.status !== 422) {
            alert(error)
          }
        })
    }
  }
}
</script>
